' LayErrDesigns.bas for FilmStar DESIGN
' Copyright 2007 FTG Software Associates
'
' This program simulates manufacturing errors
' for testing the Layer Error Analyzer

Option Explicit
DefInt i-n
DefSng A-h, O-Z

Sub Main
    Dim qAveL, qAveH, qTotH, qSubTotH, nL, nH, v
    Dim i, iLay, nLay, q(), qt$(), qd$()
    GetLayers nLay, q(), qt$(), qd$()
    For i = 1 To nLay   ' calculate averages
        Select Case qt(i)
        Case "L"
            qAveL = qAveL + q(i)
            nL = nL + 1
        Case "H"
            qAveH = qAveH + q(i)
            nH = nH + 1
        End Select
    Next i
    qAveL = qAveL/nL    ' average L thickness
    qAveH = qAveH/nH    ' average H thickness
    For i=1 To nLay
        Select Case qt$(i)
        Case "L"
            ' error is function of layer thickness q(i)
            v = q(i)/qAveL      ' normalize
            q(i) = Round(q(i)*(1 + .001*RndNorm + v*(.01 + .001*v)), 4)
        Case "H"
            ' error is function of total thickness qTotH
            qTotH = qSubTotH + .5*q(i)
            qSubTotH = qSubTotH + q(i)
            v = qTotH/qAveH     ' normalize
            q(i) = Round(q(i)*(1 + .002*RndNorm + v*(.0002 - .0005*v)), 4)
        End Select
    Next i
    SetLayers q(), qt() ' design now has errors
End Sub

