Attribute VB_Name = "Module1"
'#Reference {101F9C56-A0F3-455C-ABBB-191168ABCF94}#1.0#0#C:\Program Files\Chilkat Software Inc\Chilkat XML\ChilkatXml.dll#Chilkat XML 5.0.0
'  Program SproExportNK.bas for FilmStar INDEX
'         Copyright FTG Software 2005
' Exports indices to SYRUSpro XML files (.ldd)
'
' *********************************************
'   Uses ChilkatXML www.chilkatsoft.com (free)
'    Direct link to ChilkatXML installer:
'  www.chilkatsoft.com/download/XmlActiveX.msi
'
'    XML Schema LeyboldMonitoringReport.xsd
' *****************************************************
'                 REVISION 1.00
'         MAKE SURE THIS PATH EXISTS
Const SproPath$ = "c:\Winfilm\Course2\Monitor\SYRUSpro"
' *****************************************************
Option Explicit
DefLng i-n
DefSng A-H, O-Z
Option Base 1
Dim xml0 As ChilkatXml
Public XMLFile$, file$, matl$, nTyp$, kTyp$
Public nkVals!(), coeff!(), range!()
Const title$ = "SYRUSpro Export Index"

Sub Main
    GetIndex
    Set xml0 = New ChilkatXml
    With xml0
        .Tag = "dispersion"
        .AddAttribute "name", file$
        .AddAttribute "type", "Layer"
        .AddAttribute "material", matl$
        .AddAttribute "uuid", LCase$(UUID)
        .AddAttribute "version", "1.00"
        .AddAttribute "xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance"
        .AddAttribute "xsi:noNamespaceSchemaLocation", "LeyboldDispersion.xsd"
    End With
    AddDispersion xml0
    xml0.SaveXml SproPath$ & "\" & IndexName & ".ldd"
    MsgBox "XML file " & IndexName & ".ldd successfully created!", vbOkCancel, title$
    End
SetIndexErr:
    MsgBox Err.Description, vbCritical, title$ & " Error"
    End
End Sub

Sub AddDispersion(xml As ChilkatXml)
    Dim i, nco, file$
    With xml
        With .FindOrAddNewChild("range")
            .AddAttribute "min", CStr$(range(1))
            .AddAttribute "max", CStr$(range(2))
        End With
        If nTyp$ = "NKTable" Then
            With .FindOrAddNewChild("complex_refractive_index_table")
                For i=1 To UBound(nkVals, 1)
                    With .NewChild("row", "")
                        .AddAttribute "wavelength", CStr$(nkVals(i, 1))
                        .AddAttribute "n", CStr$(nkVals(i, 2))
                        .AddAttribute "k", CStr$(nkVals(i, 3))
                    End With
                Next i
            End With
        Else
            With .FindOrAddNewChild("refractive_index")
                If nTyp$ = "Table" Then
                    nco = 0
                    .AddAttribute("method", "Table")
                    For i=1 To UBound(nkVals, 1)
                        With .NewChild("row", "")
                            .AddAttribute "wavelength", CStr$(nkVals(i, 1))
                            .AddAttribute "n", CStr$(nkVals(i, 2))
                        End With
                    Next i
                Else
                    nco = UBound(coeff)
                    Select Case nTyp$
                    Case "Sell1"
                        .AddAttribute("method", "Sellmeier1")
                        With .FindOrAddNewChild("coefficientsNSellmeier1")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Sell2"
                        .AddAttribute("method", "Sellmeier2")
                        With .FindOrAddNewChild("coefficientsNSellmeier2")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Sell2'"
                        .AddAttribute("method", "Sellmeier2TickMark")
                        With .FindOrAddNewChild("coefficientsNSellmeier2TickMark")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Sell3"
                        .AddAttribute("method", "Sellmeier3")
                        With .FindOrAddNewChild("coefficientsNSellmeier3")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Cauchy"
                        .AddAttribute("method", "Cauchy")
                        With .FindOrAddNewChild("coefficientsNCauchy")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Hart1"
                        .AddAttribute("method", "Hartmann1")
                        With .FindOrAddNewChild("coefficientsNHartmann1")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    Case "Hart2"
                        .AddAttribute("method", "Hartmann2")
                        With .FindOrAddNewChild("coefficientsNHartmann2")
                            For i = 1 To nco
                                .AddAttribute "a" & CStr$(i-1), CStr$(coeff(i))
                            Next i
                        End With
                    End Select
                End If
            End With
        End If
        If nTyp$ <> "NKTable" Then
            With .FindOrAddNewChild("extinction_coefficient")
                Select Case kTyp$
                Case "Zero", ""
                    .AddAttribute("method", "Zero")
                Case "Table"
                    .AddAttribute("method", "Table")
                    For i=1 To UBound(nkVals, 1)
                        With .NewChild("row", "")
                            .AddAttribute "wavelength", CStr$(nkVals(i, 1))
                            .AddAttribute "k", CStr$(nkVals(i, 3))
                        End With
                    Next i
                Case "Sell"
                    .AddAttribute("method", "Sellmeier")
                    With .FindOrAddNewChild("coefficientsKSellmeier")
                        For i = 1 To UBound(coeff)
                            .AddAttribute "b" & CStr$(i-1), CStr$(coeff(i + nco))
                        Next i
                    End With
                Case "Exp"
                    .AddAttribute("method", "Exponential")
                    With .FindOrAddNewChild("coefficientsKExponential")
                        For i = 1 To UBound(coeff)
                            .AddAttribute "b" & CStr$(i-1), CStr$(coeff(i + nco))
                        Next i
                    End With
                End Select
            End With
        End If
    End With
End Sub

Sub GetIndex()
    Const t$ = "Get Index Information"
    Dim i, k1, k2, m, code$, s$
    code$ = FunctionCode
    file$ = IndexName      ' get current file name
    k1 = InStr(code$,"SPRO:")
    If k1 = 0 Then
        MsgBox "Invalid SYRUSpro code", vbCritical, t$
        End
    End If
    k2 = InStr(code$, "|")
    If k2 = 0 Then
        MsgBox "Invalid SYRUSpro code", vbCritical, t$
        End
    Else
        matl$ = Mid$(code$, k2 + 1)
        If matl$="" Then
            MsgBox "Invalid SYRUSpro code", vbCritical, t$
            End
        Else
            Mid$(code$, k2) = ""
        End If
    End If

    code$ = Mid$(code$, k1 + 5)
    k1 = InStr(code$, ",")
    If k1 = 0 Then
        nTyp$ = Mid$(code$, 1, InStr(code$, "|") - 1)
        kTyp$ = ""
    Else
        nTyp$ = Mid$(code$, 1, k1 - 1)
        kTyp$ = Mid$(code$, k1 + 1, InStr(code$, "|") - k1 - 1)
    End If
    If nTyp$ = "NKTable" Then
        nkVals = nkTable
    Else
        Select Case nTyp$
        Case "Table"
            nkVals = nkTable
        Case "Sell1", "Sell2", "Sell2'", "Sell3", "Cauchy", "Hart1", "Hart2"
            coeff = FunctionCoeff
        Case Else
            MsgBox "Undefined SYRUSpro code for index n", vbCritical, t$
            End
        End Select

        Select Case kTyp$
        Case "Zero", ""
        Case "Table"
            nkVals = nkTable
        Case "Sell", "Exp"
            coeff = FunctionCoeff
        Case Else
            MsgBox "Undefined SYRUSpro code for index k", vbCritical, t$
            End
        End Select
    End If
    range = FunctionRange
End Sub

